from ..cache import Cache


class CachedSource:

    def __init__(self, size=1):
        if not self.is_connected:
            raise RuntimeError(f"{self.pvname} is not connected, cannot attach cache")

        self.cache = cache = Cache(size=size)
        self._cb = self.add_callback(cache.callback_append, with_ctrlvars=False)

    def disconnect(self):
        self.remove_callback(self._cb)



