from bokeh.palettes import (
    Viridis256,
    Cividis256,

    Inferno256,
    Magma256,
    Plasma256,

    Turbo256,
    Greys256
)

from colorcet import (
    fire,
    rainbow,
    isolum,

    coolwarm,
    bkr,
    b_diverging_gwr_55_95_c38
)

from .palettes import (
    kindlmann,
    kindlmann_ext,
    ocean_sunrise,
    coolwarm_ext,
    painbow
)


cmaps = {
    # viridian:
    "Viridis": Viridis256,
    "Cividis": Cividis256,

    # fiery:
    "Fire": fire,
    "Inferno": Inferno256,
    "Magma": Magma256,
    "Plasma": Plasma256,

    # spectral:
    "Rainbow": rainbow,
    "Turbo": Turbo256,
    "Greyscale": Greys256,
    "IsoLum": isolum,
    "Kindlmann": kindlmann,
    "Kindlmann Ext": kindlmann_ext,
    "Painbow": painbow,

    # divergent:
    "CoolWarm": coolwarm,
    "CoolWarm Ext": coolwarm_ext,
    "CoolBlackWarm": bkr,
    "Ocean Sunrise": ocean_sunrise,
    "Italia": b_diverging_gwr_55_95_c38[::-1]
}



#TODO: Alternatives to Greys?
#    Blues
#    Greens
#    Oranges
#    Purples
#    Reds

#TODO: cyclic?



